import QtQuick 2.15
import QtQuick.Layouts 1.15
import org.ukui.quick.widgets 1.0
import org.ukui.quick.items 1.0

WidgetItem {
    property bool panelOrientation: (Widget.orientation === Types.Horizontal)
    property int pos: Widget.container.position
    Layout.fillWidth: panelOrientation ? false : true
    Layout.fillHeight: panelOrientation ? true : false
    Layout.preferredWidth: childrenRect.width
    Layout.preferredHeight: childrenRect.height
    clip: true
    Widget.active: dropArea.panelActive

    TrayView {
        id: dropArea
        property bool panelActive: false
        scaleFactor: parent.panelOrientation ? (parent.height / 44) * 8 : (parent.width / 44) * 8
        itemOrientation: parent.panelOrientation
        itemWidth: parent.panelOrientation ? scaleFactor * 4 : scaleFactor * 5
        itemHeight: parent.panelOrientation ? scaleFactor * 5 : scaleFactor * 4
        itemLong: scaleFactor * 5
        itemShort: scaleFactor * 4
        panelPos: parent.pos

        function updateCurrentLength() {
            if ((parent.width === 0) || (parent.height === 0)) return;
            if (parent.width === parent.height) return;
            if (parent.parent.trayMaxLength <= 0) return;
            if (parent.panelOrientation) {
                if (parent.width > parent.height) {
                    scaleFactor = (parent.height / 44) * 8;
                    maxLength = parent.parent.trayMaxLength;
                    currentLength = parent.width;
                }
            } else {
                if (parent.width < parent.height) {
                    scaleFactor = (parent.width / 44) * 8;
                    maxLength = parent.parent.trayMaxLength;
                    currentLength = parent.height;
                }
            }
        }
    }

    onWidthChanged: {
        dropArea.changeFoldWindowPosition();
        dropArea.updateCurrentLength();
    }

    onHeightChanged: {
        dropArea.changeFoldWindowPosition();
        dropArea.updateCurrentLength();
    }
}
